﻿//fullCollectFonts.jsx
//InDesign
//Collect in custom folder all styles of fonts of current document.
//Скрипт копирует в выбраный каталог полные наборы шрифтов открытой публикации.
//alexey-dmitrienko@ya.ru, 2010
//scriptuibuilder.com
// v.1.1


if( !app.documents.length ){
	alert( 'No open documents' );
	exit();
	}

collectFolder = Folder.selectDialog( 'Select folder for collect' );
if( !collectFolder )
	exit();
docFonts = app.activeDocument.fonts;
fontFamilies = {};
fonts = [];
collectFiles = [];
errors = '';
progress = getProgressWindow( docFonts.length, 'font list...' );
progress.center();
progress.show();
for( i = 0; i < docFonts.length; i++ ){
	if( !fontFamilies[docFonts[i].fontFamily] ){
		fontFamilies[docFonts[i].fontFamily] = true;
		fonts.push( docFonts[i] );
		}
	progress.setValue();
	}
progress.text = 'collect files...';

for( i = 0; i < fonts.length; i++ ){
	font = app.fonts.itemByName( fonts[i].name );
	pushFontFile( collectFiles, font );
	index = font.index;
	while( app.fonts[--index].fontFamily == font.fontFamily )
		pushFontFile( collectFiles, app.fonts[index] );
	index = font.index;
	while( app.fonts[++index].fontFamily == font.fontFamily )
		pushFontFile( collectFiles, app.fonts[index] );
	progress.setValue();
	}
progress.text = 'copy files...';
for( i = 0; i < collectFiles.length; i++ ){
	collectFiles[i].copy( collectFolder.fsName + '/' + collectFiles[i].displayName );
	progress.setValue();
	}
progress.close();
if( errors ){
	file = File( collectFolder.fsName + '/0_collectErrors.txt' );
	file.open('w');
	file.write(errors);
	file.close();
	alert( errors + '\r\rReport writen in file:\r' + file.fsName );
	}
collectFolder.execute();

//========================================================
function pushFontFile( array, font ){
	try{
		array.push( File(font.location) );
		}catch(err){
			errors += '\r' + 'error: font.location: ' + font.name;
			}
	}
//========================================================
function getProgressBar( container, maxValue, size, location ){// return progressbar{ setValue: function( [num] ) }
	/*
	Note: in scripts that use progress bars, you cannot set
	app.scriptPreferences.enableRedraw to false. If you do, the progress
	bar doesn't display correctly. This is on Macs only.
	*/
	if( /indesign/i.test(app.name) )
		app.scriptPreferences.enableRedraw = true;
	size = size || [200, 8];
	location = location || [0,0];
	var pBar = container.add('progressbar', [location[0], location[1], location[0]+size[0], location[1]+size[1]], 0, maxValue);
	pBar.setValue = function( num ){
		num = num || 1;
		if( this.value >= maxValue ) this.value = 0;
		this.value += num;
		};
	return pBar;
	}
function getProgressWindow( maxValue, title ){//return palette{ setValue: function( [num] ) }
	title = title || 'Progress';
	var myProgressPanel = new Window('palette', title);
	myProgressPanel.progressBar = this.getProgressBar( myProgressPanel, maxValue );
	myProgressPanel.setValue = function( num ){
		this.progressBar.setValue( num );
		}
	return myProgressPanel;
	}